"""Blocks World problem"""

from search import * # This file imports utils.py so it should be in the same folder
import sys # System-specific parameters and functions

class BlocksWorld(Problem) :
    """Subclass of search.Problem"""

    def __init__(self, initial, goal) :
        """Sets initial state and goal."""
        super(BlocksWorld, self).__init__(initial, goal)

#_______________________________________________________________

    def actions(self, state) :
        """Returns the actions that can be executed in the state"""
        validActions = []

        for i in range(len(state)) :
            if len(state[i]) > 1 : #Current list with more than one cubes
                validActions.append((i, -1)) #Top cube can be transfered to a new list
            for j in range(len(state)) : #For all the lists in the state
                if j != i : #Except the one the cube currently is
                    validActions.append((i, j)) #The top cube can be transfered there

        return tuple(validActions)

#_______________________________________________________________

    def result(self, state, action) :
        """Returns the state after the action has been applied"""
        state = list(state)
        src = action[0]
        dest = action[1]
        state[src] = list(state[src])

        if dest == -1 : #Move cube from source to a new list
            state.append((state[src].pop(), ))
            state[src] = tuple(state[src])
        else : #Move cube from source to destination
            state[dest] = list(state[dest])
            state[dest].append(state[src].pop())
            state[dest] = tuple(state[dest])
            
            if len(state[src]) == 0 : #If source list empty delete it
                state.pop(src)
            else :
                state[src] = tuple(state[src])

        return tuple(state)
    
#_______________________________________________________________    

    def goal_test(self, state):
        """Return True if the state is a goal."""
        for i in range(len(state)) :
            if state[i] not in self.goal :
                return False

        return True
